Loading...
Searching...
No Matches
find_perm.h File Reference
`#include "coeffs/coeffs.h"`
`#include "polys/matpol.h"`

Go to the source code of this file.

## Functions

matrix | ma_ApplyPermForMap (const matrix to_map, const ring preimage_r, const ideal image, const ring image_r, const nMapFunc nMap)
| helper function for maMapIdeal mapping ideal/matrix/module for the case of a permutation: maps the ideal/module/matrix to_map via the map from preimage_r with image image and mapping of coefficients via nMap (or return NULL)

## Function Documentation

## ma_ApplyPermForMap()

matrix ma_ApplyPermForMap | ( | const matrix | to_map,
|  | const ring | preimage_r,
|  | const ideal | image,
|  | const ring | image_r,
|  | const nMapFunc | nMap )

helper function for maMapIdeal mapping ideal/matrix/module for the case of a permutation: maps the ideal/module/matrix to_map via the map from preimage_r with image image and mapping of coefficients via nMap (or return NULL)

Definition at line 69 of file find_perm.cc.

{
if ((rPar(preimage_r)>0)||(rPar(image_r)>0)) return NULL; /* not applicable */
int *perm=find_perm_for_map(preimage_r,image_r,image);
if (perm==NULL) return NULL; /* could not find permutation */
int C=to_map->cols();
int R=to_map->rows();
matrix m=mpNew(R,C);
for (int i=R*C-1;i>=0;i--)
{
if (to_map->m[i]!=NULL)
{
m->m[i]=p_PermPoly(to_map->m[i],perm,preimage_r,image_r, nMap,NULL,0);
p_Test(m->m[i],image_r);
}
}
ideal ii=(ideal)m;
ii->rank=((ideal)to_map)->rank;
omFreeSize(perm,(preimage_r->N+1)*sizeof(int));
return m;
}
m
int m
Definition cfEzgcd.cc:128
i
int i
Definition cfEzgcd.cc:132
ip_smatrix::m
poly * m
Definition matpol.h:18
ip_smatrix::cols
int & cols()
Definition matpol.h:24
ip_smatrix::rows
int & rows()
Definition matpol.h:23
find_perm_for_map
static int * find_perm_for_map(const ring preimage_r, const ring image_r, const ideal image)
Definition find_perm.cc:19
mpNew
matrix mpNew(int r, int c)
create a r x c zero-matrix
Definition matpol.cc:37
matrix
ip_smatrix * matrix
Definition matpol.h:43
omFreeSize
#define omFreeSize(addr, size)
Definition omAllocDecl.h:260
NULL
#define NULL
Definition omList.c:12
p_PermPoly
poly p_PermPoly(poly p, const int *perm, const ring oldRing, const ring dst, nMapFunc nMap, const int *par_perm, int OldPar, BOOLEAN use_mult)
Definition p_polys.cc:4256
p_Test
#define p_Test(p, r)
Definition p_polys.h:161
rPar
static int rPar(const ring r)
(r->cf->P)
Definition ring.h:605
R
#define R
Definition sirandom.c:27